#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <Arduino.h>
#include "scpiparser.h"
#include "test.h"

void dump_command(struct scpi_command* command) {

  if (command != NULL) {
    Serial.println(F("CMD dump"));
    Serial.println(command->long_name);
    Serial.println(command->short_name);
    Serial.print(F("Next     : ")); Serial.println((unsigned int)command->next);
    Serial.print(F("children : ")); Serial.println((unsigned int)command->children);
    Serial.print(F("callback : ")); Serial.println((unsigned int)command->callback);
  } else {
    Serial.println(F("Command NULL")); 
  }
}

void dump_cmd_string(char * str) {
  int i;

  Serial.println(F("CMD string"));
  for(i=0; i<100; i++, str++) {
    if (*str == 0) {
      Serial.print('/');
    } else if (*str < 0x20) {
      Serial.print('%'); 
    } else {
      Serial.print(*str);
    }
  }
  Serial.println();
}

void dump_token_list(struct scpi_token* token) {
  int i;
  
  Serial.println(F("Token list dump"));
  for (i=1; token != NULL; token = token->next, i++) {
    Serial.print(i); Serial.print(' ');
    Serial.print(token->type); Serial.print(' ');
    Serial.print(token->value);
    Serial.println();
  }
}

void dump_cmd_tree(struct scpi_command* cmd, int level) {
  int i, j;

  if (level == 0) Serial.println(F("Command Tree"));

  for (i=1; cmd != NULL; i++, cmd = cmd->next) {
    for (j=2*level; j>0; j--) Serial.print(' ');  
    Serial.print(i); Serial.print(": ");
    if (level == 0 && cmd->long_name == NULL) {
      Serial.println(F("root"));
    } else {
      Serial.print(cmd->long_name); Serial.print(' ');
      Serial.println(cmd->short_name);
    }
    if (cmd->children != NULL) {
      dump_cmd_tree(cmd->children, level+1);
    }    
  }
}
  
